diff --git a/applications/mp4box/main.c b/applications/mp4box/main.c
index 99b4c39a07..dc7f10b6b7 100644
--- a/applications/mp4box/main.c
+++ b/applications/mp4box/main.c
@@ -3079,7 +3079,7 @@ int mp4boxMain(int argc, char **argv)
 
 #ifndef GPAC_DISABLE_MPD
 	if (do_mpd) {
-		Bool remote = 0;
+		Bool remote = GF_FALSE;
 		char *mpd_base_url = gf_strdup(inName);
 		if (!strnicmp(inName, "http://", 7)) {
 #if !defined(GPAC_DISABLE_CORE_TOOLS)
@@ -3090,13 +3090,14 @@ int mp4boxMain(int argc, char **argv)
 				MP4BOX_EXIT_WITH_CODE(1);
 			}
 			inName = "tmp_main.m3u8";
-			remote = 1;
+			remote = GF_TRUE;
 #else
+			gf_free(mpd_base_url);
 			fprintf(stderr, "HTTP Downloader disabled in this build\n");
 			MP4BOX_EXIT_WITH_CODE(1);
 #endif
 		}
-		e = gf_m3u8_to_mpd(inName, mpd_base_url, (outName ? outName : inName), 0, "video/mp2t", 1, use_url_template, NULL);
+		e = gf_m3u8_to_mpd(inName, mpd_base_url, (outName ? outName : inName), 0, "video/mp2t", GF_TRUE, use_url_template, NULL);
 		gf_free(mpd_base_url);
 
 		if (remote) {
diff --git a/src/media_tools/m3u8.c b/src/media_tools/m3u8.c
index 248cb3557c..bdc9ea0b65 100644
--- a/src/media_tools/m3u8.c
+++ b/src/media_tools/m3u8.c
@@ -29,6 +29,9 @@
 #include <gpac/network.h>
 
 
+
+/********** playlist_element **********/
+
 GF_Err playlist_element_del(PlaylistElement * e);
 
 static GF_Err cleanup_list_of_elements(GF_List *list) {
@@ -87,43 +90,6 @@ GF_Err playlist_element_del(PlaylistElement * e) {
 	return result;
 }
 
-/**
- * Creates a new program properly initialized
- */
-static Stream* stream_new(int stream_id) {
-	Stream *program = (Stream *) gf_malloc(sizeof(Stream));
-	if (program == NULL) {
-		return NULL;
-	}
-	program->stream_id = stream_id;
-	program->variants = gf_list_new();
-	if (program->variants == NULL) {
-		gf_free(program);
-		return NULL;
-	}
-	return program;
-}
-
-/**
- * Deletes the specified stream
- */
-static GF_Err stream_del(Stream *stream) {
-	GF_Err e = GF_OK;
-	if (stream == NULL)
-		return e;
-	if (stream->variants) {
-		while (gf_list_count(stream->variants)) {
-			GF_List *l = gf_list_get(stream->variants, 0);
-			cleanup_list_of_elements(l);
-			gf_list_rem(stream->variants, 0);
-		}
-		gf_list_del(stream->variants);
-	}
-	stream->variants = NULL;
-	gf_free(stream);
-	return e;
-}
-
 /**
  * Creates an Playlist element.
  * This element can be either a playlist of a stream according to first parameter.
@@ -132,7 +98,6 @@ static GF_Err stream_del(Stream *stream) {
 static PlaylistElement* playlist_element_new(PlaylistElementType element_type, const char *url, const char *title, const char *codecs, double duration_info, u64 byte_range_start, u64 byte_range_end) {
 	PlaylistElement *e = gf_malloc(sizeof(PlaylistElement));
 	memset(e, 0, sizeof(PlaylistElement));
-	assert(url);
 	if (e == NULL)
 		return NULL;
 	e->duration_info = duration_info;
@@ -179,92 +144,48 @@ static PlaylistElement* playlist_element_new(PlaylistElementType element_type, c
 	return e;
 }
 
+
+/********** stream **********/
+
 /**
- * Creates a new MasterPlaylist
- * \return NULL if MasterPlaylist element could not be allocated
+ * Creates a new stream properly initialized
  */
-MasterPlaylist* master_playlist_new()
-{
-	MasterPlaylist *pl = (MasterPlaylist*)gf_malloc(sizeof(MasterPlaylist));
-	if (pl == NULL)
+static Stream* stream_new(int stream_id) {
+	Stream *program = (Stream *) gf_malloc(sizeof(Stream));
+	if (program == NULL) {
 		return NULL;
-	pl->streams = gf_list_new();
-	if (!pl->streams) {
-		gf_free(pl);
+	}
+	program->stream_id = stream_id;
+	program->variants = gf_list_new();
+	if (program->variants == NULL) {
+		gf_free(program);
 		return NULL;
 	}
-	pl->current_stream = -1;
-	pl->playlist_needs_refresh = GF_TRUE;
-	return pl;
+	return program;
 }
 
-GF_Err gf_m3u8_master_playlist_del(MasterPlaylist *playlist) {
-	if (playlist == NULL)
-		return GF_OK;
-	assert(playlist->streams);
-	while (gf_list_count(playlist->streams)) {
-		Stream *p = gf_list_get(playlist->streams, 0);
-		assert(p);
-		while (gf_list_count(p->variants)) {
-			PlaylistElement *pl = gf_list_get(p->variants, 0);
-			assert(pl);
-			playlist_element_del(pl);
-			gf_list_rem(p->variants, 0);
+/**
+ * Deletes the specified stream
+ */
+static GF_Err stream_del(Stream *stream) {
+	GF_Err e = GF_OK;
+	if (stream == NULL)
+		return e;
+	if (stream->variants) {
+		while (gf_list_count(stream->variants)) {
+			GF_List *l = gf_list_get(stream->variants, 0);
+			cleanup_list_of_elements(l);
+			gf_list_rem(stream->variants, 0);
 		}
-		gf_list_del(p->variants);
-		p->variants = NULL;
-		stream_del(p);
-		gf_list_rem(playlist->streams, 0);
+		gf_list_del(stream->variants);
 	}
-	gf_list_del(playlist->streams);
-	playlist->streams = NULL;
-	gf_free(playlist);
-
-	return GF_OK;
+	stream->variants = NULL;
+	gf_free(stream);
+	return e;
 }
 
-static GF_Err playlist_element_dump(const PlaylistElement *e, int indent) {
-	int i;
-	GF_Err r = GF_OK;
-	for (i=0; i<indent; i++)
-		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, (" "));
-	if (e == NULL) {
-		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[M3U8] NULL PlaylistElement\n"));
-		return r;
-	}
-	GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[M3U8] PlayListElement[%p, title=%s, codecs=%s, duration=%d, bandwidth=%d, url=%s, type=%s]\n",
-	                                   (void*)e, e->title, e->codecs, e->duration_info, e->bandwidth, e->url,
-	                                   e->element_type == TYPE_MEDIA ? "media" : "playlist"));
-	if (TYPE_PLAYLIST == e->element_type) {
-		int sz;
-		assert(e->element.playlist.elements);
-		sz = gf_list_count(e->element.playlist.elements);
-		indent += 2;
-		for (i=0 ; i<sz; i++) {
-			PlaylistElement *elt = gf_list_get(e->element.playlist.elements, i);
-			assert(elt);
-			r |= playlist_element_dump(elt, indent);
-		}
-	}
-	return r;
-}
 
-static Stream* master_playlist_find_matching_stream(const MasterPlaylist *pl, const u32 stream_id) {
-	u32 count, i;
-	assert(pl);
-	assert(pl->streams);
-	assert(stream_id >= 0);
-	count = gf_list_count(pl->streams);
-	for (i=0; i<count; i++) {
-		Stream *cur = gf_list_get(pl->streams, i);
-		assert(cur);
-		if (stream_id == cur->stream_id) {
-			/* We found the program */
-			return cur;
-		}
-	}
-	return NULL;
-}
+/********** accumulated_attributes **********/
 
 typedef enum _e_MediaType {
 	MEDIA_TYPE_UNKNOWN         = 0,
@@ -474,21 +395,21 @@ static char** parse_attributes(const char *line, s_accumulated_attributes *attri
 	ret = extract_attributes("#EXT-X-PROGRAM-DATE-TIME:", line, 1);
 	if (ret) {
 		/* #EXT-X-PROGRAM-DATE-TIME:<YYYY-MM-DDThh:mm:ssZ> */
-		GF_LOG(GF_LOG_WARNING, GF_LOG_DASH,("[M3U8] EXT-X-PROGRAM-DATE-TIME not supported.\n", line));
+		GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] EXT-X-PROGRAM-DATE-TIME not supported.\n", line));
 		M3U8_COMPATIBILITY_VERSION(1);
 		return ret;
 	}
 	ret = extract_attributes("#EXT-X-ALLOW-CACHE:", line, 1);
 	if (ret) {
 		/* #EXT-X-ALLOW-CACHE:<YES|NO> */
-		GF_LOG(GF_LOG_WARNING, GF_LOG_DASH,("[M3U8] EXT-X-ALLOW-CACHE not supported.\n", line));
+		GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] EXT-X-ALLOW-CACHE not supported.\n", line));
 		M3U8_COMPATIBILITY_VERSION(1);
 		return ret;
 	}
 	ret = extract_attributes("#EXT-X-PLAYLIST-TYPE", line, 1);
 	if (ret) {
 		/* #EXT-X-PLAYLIST-TYPE:<EVENT|VOD> */
-		GF_LOG(GF_LOG_WARNING, GF_LOG_DASH,("[M3U8] EXT-X-PLAYLIST-TYPE not supported.\n", line));
+		GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] EXT-X-PLAYLIST-TYPE not supported.\n", line));
 		M3U8_COMPATIBILITY_VERSION(3);
 		return ret;
 	}
@@ -601,13 +522,13 @@ static char** parse_attributes(const char *line, s_accumulated_attributes *attri
 					return NULL;
 				}
 			} else if (safe_start_equals("LANGUAGE=", ret[i])) {
-				GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] #EXT-X-MEDIA:LANGUAGE not supported\n"));
+				GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] EXT-X-MEDIA:LANGUAGE not supported\n"));
 				//attributes->language = gf_strdup(ret[i]+9);
 			} else if (safe_start_equals("NAME=", ret[i])) {
-				GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] #EXT-X-MEDIA:NAME not supported\n"));
+				GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] EXT-X-MEDIA:NAME not supported\n"));
 				//attributes->name = gf_strdup(ret[i]+5);
 			} else if (safe_start_equals("DEFAULT=", ret[i])) {
-				GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] #EXT-X-MEDIA:DEFAULT not supported\n"));
+				GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] EXT-X-MEDIA:DEFAULT not supported\n"));
 				if (!strncmp(ret[i]+8, "YES", 3)) {
 					//TODO
 				} else if (!strncmp(ret[i]+8, "NO", 2)) {
@@ -616,7 +537,7 @@ static char** parse_attributes(const char *line, s_accumulated_attributes *attri
 					GF_LOG(GF_LOG_WARNING, GF_LOG_DASH,("[M3U8] Invalid #EXT-X-MEDIA:DEFAULT=%s\n", ret[i]+8));
 				}
 			} else if (safe_start_equals("AUTOSELECT=", ret[i])) {
-				GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] #EXT-X-MEDIA:AUTOSELECT not supported\n"));
+				GF_LOG(GF_LOG_INFO, GF_LOG_DASH,("[M3U8] EXT-X-MEDIA:AUTOSELECT not supported\n"));
 				if (!strncmp(ret[i]+11, "YES", 3)) {
 					//TODO
 				} else if (!strncmp(ret[i]+11, "NO", 2)) {
@@ -654,6 +575,73 @@ static char** parse_attributes(const char *line, s_accumulated_attributes *attri
 	return NULL;
 }
 
+/**
+ * Creates a new MasterPlaylist
+ * \return NULL if MasterPlaylist element could not be allocated
+ */
+MasterPlaylist* master_playlist_new()
+{
+	MasterPlaylist *pl = (MasterPlaylist*)gf_malloc(sizeof(MasterPlaylist));
+	if (pl == NULL)
+		return NULL;
+	pl->streams = gf_list_new();
+	if (!pl->streams) {
+		gf_free(pl);
+		return NULL;
+	}
+	pl->current_stream = -1;
+	pl->playlist_needs_refresh = GF_TRUE;
+	return pl;
+}
+
+
+/********** master_playlist **********/
+
+GF_Err gf_m3u8_master_playlist_del(MasterPlaylist *playlist) {
+	if (playlist == NULL)
+		return GF_OK;
+	assert(playlist->streams);
+	while (gf_list_count(playlist->streams)) {
+		Stream *p = gf_list_get(playlist->streams, 0);
+		assert(p);
+		while (gf_list_count(p->variants)) {
+			PlaylistElement *pl = gf_list_get(p->variants, 0);
+			assert(pl);
+			playlist_element_del(pl);
+			gf_list_rem(p->variants, 0);
+		}
+		gf_list_del(p->variants);
+		p->variants = NULL;
+		stream_del(p);
+		gf_list_rem(playlist->streams, 0);
+	}
+	gf_list_del(playlist->streams);
+	playlist->streams = NULL;
+	gf_free(playlist);
+
+	return GF_OK;
+}
+
+static Stream* master_playlist_find_matching_stream(const MasterPlaylist *pl, const u32 stream_id) {
+	u32 count, i;
+	assert(pl);
+	assert(pl->streams);
+	assert(stream_id >= 0);
+	count = gf_list_count(pl->streams);
+	for (i=0; i<count; i++) {
+		Stream *cur = gf_list_get(pl->streams, i);
+		assert(cur);
+		if (stream_id == cur->stream_id) {
+			/* We found the program */
+			return cur;
+		}
+	}
+	return NULL;
+}
+
+
+/********** sub_playlist **********/
+
 #define M3U8_BUF_SIZE 2048
 
 GF_EXPORT
@@ -766,7 +754,10 @@ GF_Err declare_sub_playlist(char *currentLine, const char *baseURL, s_accumulate
 				return GF_OUT_OF_MEM;
 			}
 			assert(fullURL);
+			if (curr_playlist->url)
+				gf_free(curr_playlist->url);
 			curr_playlist->url = gf_strdup(fullURL);
+			assert(!curr_playlist->title && !curr_playlist->codecs);
 			curr_playlist->title = attribs->title ? gf_strdup(attribs->title) : NULL;
 			curr_playlist->codecs = attribs->codecs ? gf_strdup(attribs->codecs) : NULL;
 			if (curr_playlist->audio_group) {
@@ -800,7 +791,7 @@ GF_Err declare_sub_playlist(char *currentLine, const char *baseURL, s_accumulate
 				}
 				assert(curr_playlist->element.playlist.elements);
 				assert(fullURL);
-				assert(curr_playlist->url);
+				assert(curr_playlist->url && !curr_playlist->title && !curr_playlist->codecs);
 				curr_playlist->title = NULL;
 				curr_playlist->codecs = NULL;
 				subElement = playlist_element_new(
diff --git a/src/media_tools/mpd.c b/src/media_tools/mpd.c
index 45872f66b1..262a2ee61e 100644
--- a/src/media_tools/mpd.c
+++ b/src/media_tools/mpd.c
@@ -1107,10 +1107,11 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 
 	the_pe = NULL;
 	pe = NULL;
-	i = 0, j = 0, k = 0;
+	i = 0;
 	assert(pl);
 	assert(pl->streams);
 	while ((stream = gf_list_enum(pl->streams, &i))) {
+		j = 0;
 		while (NULL != (pe = gf_list_enum(stream->variants, &j))) {
 			Bool found = GF_FALSE;
 			char *suburl;
@@ -1166,18 +1167,21 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 				}
 				gf_service_download_del(sess);
 #endif
-				gf_free(suburl);
 			} else { /* for use in MP4Box */
 				if (strstr(suburl, "://")) {
+					GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD Generator] Downloading %s...\n", suburl));
 					e = gf_dm_wget(suburl, "tmp.m3u8", 0, 0);
 					if (e == GF_OK) {
 						e = gf_m3u8_parse_sub_playlist("tmp.m3u8", &pl, suburl, stream, pe);
+					} else {
+						GF_LOG(GF_LOG_WARNING, GF_LOG_DASH, ("[MPD Generator] Download faile for %s\n", suburl));
 					}
 					gf_delete_file("tmp.m3u8");
 				} else {
 					e = gf_m3u8_parse_sub_playlist(suburl, &pl, suburl, stream, pe);
 				}
 			}
+			gf_free(suburl);
 		}
 		if (max_dur < (u32) stream->computed_duration) {
 			max_dur = (u32) stream->computed_duration;
@@ -1334,77 +1338,77 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 
 		}
 	}
+	
+	nb_streams = gf_list_count(pl->streams);
+	for (i=0; i<nb_streams; i++) {
+		u32 count_variants;
+		u32 width, height, samplerate, num_channels;
+		fprintf(fmpd, "  <AdaptationSet segmentAlignment=\"true\">\n");
 
-	fprintf(fmpd, "  <AdaptationSet segmentAlignment=\"true\">\n");
-
-	/*if we use templates, put the SegmentTemplate element at the adaptationSet level*/
-	if (use_template) {
-		fprintf(fmpd, "   <SegmentTemplate");
+		/*if we use templates, put the SegmentTemplate element at the adaptationSet level*/
+		if (use_template) {
+			fprintf(fmpd, "   <SegmentTemplate");
 
-		fprintf(fmpd, " duration=\"%d\"", pe->duration_info);
-		if (template_width > 1) {
-			fprintf(fmpd, " media=\"%s$%%0%ddNumber$%s\"", template_base, template_width, template_ext);
-		} else {
-			fprintf(fmpd, " media=\"%s$Number$%s\"", template_base, template_ext);
+			fprintf(fmpd, " duration=\"%d\"", pe->duration_info);
+			if (template_width > 1) {
+				fprintf(fmpd, " media=\"%s$%%0%ddNumber$%s\"", template_base, template_width, template_ext);
+			} else {
+				fprintf(fmpd, " media=\"%s$Number$%s\"", template_base, template_ext);
+			}
+			fprintf(fmpd, " startNumber=\"%d\"", template_idx_start);
+			fprintf(fmpd, "/>\n");
 		}
-		fprintf(fmpd, " startNumber=\"%d\"", template_idx_start);
-		fprintf(fmpd, "/>\n");
-	}
 
-	if (elt && do_import) {
-#ifndef GPAC_DISABLE_MEDIA_IMPORT
-		GF_Err e;
-		GF_MediaImporter import;
-		char *tmp_file = NULL;
-		elt = gf_list_get(pe->element.playlist.elements, 0);
-		memset(&import, 0, sizeof(GF_MediaImporter));
-		import.trackID = 0;
-		import.flags = GF_IMPORT_PROBE_ONLY;
-
-		if (strstr(elt->url, "://") && !strstr(elt->url, "file://")) {
-			tmp_file = strrchr(elt->url, '/');
-			if (!tmp_file) tmp_file = strrchr(elt->url, '\\');
-			if (tmp_file) {
-				e = gf_dm_wget(elt->url, tmp_file, 0, 0);
-				if (e==GF_OK) {
-					import.in_name = tmp_file;
-					e = gf_media_import(&import);
+		if (elt && do_import) {
+	#ifndef GPAC_DISABLE_MEDIA_IMPORT
+			GF_Err e;
+			GF_MediaImporter import;
+			char *tmp_file = NULL;
+			elt = gf_list_get(pe->element.playlist.elements, 0);
+			memset(&import, 0, sizeof(GF_MediaImporter));
+			import.trackID = 0;
+			import.flags = GF_IMPORT_PROBE_ONLY;
+
+			if (strstr(elt->url, "://") && !strstr(elt->url, "file://")) {
+				tmp_file = strrchr(elt->url, '/');
+				if (!tmp_file) tmp_file = strrchr(elt->url, '\\');
+				if (tmp_file) {
+					e = gf_dm_wget(elt->url, tmp_file, 0, 0);
+					if (e==GF_OK) {
+						import.in_name = tmp_file;
+						e = gf_media_import(&import);
+					}
 				}
+			} else {
+				import.in_name = elt->url;
+				e = gf_media_import(&import);
 			}
-		} else {
-			import.in_name = elt->url;
-			e = gf_media_import(&import);
-		}
-
-		if (import.nb_tracks > 1) {
-			for (k=0; k<import.nb_tracks; k++) {
-				fprintf(fmpd, "   <ContentComponent id=\"%d\"", import.tk_info[k].track_num);
-				if (import.tk_info[k].lang)
-					fprintf(fmpd, " lang=\"%s\"", gf_4cc_to_str(import.tk_info[k].lang));
-				switch (import.tk_info[k].type) {
-				case GF_ISOM_MEDIA_VISUAL:
-					fprintf(fmpd, " contentType=\"video\"");
-					break;
-				case GF_ISOM_MEDIA_AUDIO:
-					fprintf(fmpd, " contentType=\"audio\"");
-					break;
-				default:
-					fprintf(fmpd, " contentType=\"application\"");
-					break;
+
+			if (import.nb_tracks > 1) {
+				for (k=0; k<import.nb_tracks; k++) {
+					fprintf(fmpd, "   <ContentComponent id=\"%d\"", import.tk_info[k].track_num);
+					if (import.tk_info[k].lang)
+						fprintf(fmpd, " lang=\"%s\"", gf_4cc_to_str(import.tk_info[k].lang));
+					switch (import.tk_info[k].type) {
+					case GF_ISOM_MEDIA_VISUAL:
+						fprintf(fmpd, " contentType=\"video\"");
+						break;
+					case GF_ISOM_MEDIA_AUDIO:
+						fprintf(fmpd, " contentType=\"audio\"");
+						break;
+					default:
+						fprintf(fmpd, " contentType=\"application\"");
+						break;
+					}
+					fprintf(fmpd, "/>\n");
 				}
-				fprintf(fmpd, "/>\n");
 			}
+			if (tmp_file)
+				gf_delete_file(tmp_file);
+	#endif
 		}
-		if (tmp_file)
-			gf_delete_file(tmp_file);
-#endif
-	}
 
-	/*check if we use templates*/
-	nb_streams = gf_list_count(pl->streams);
-	for (i=0; i<nb_streams; i++) {
-		u32 count_variants;
-		u32 width, height, samplerate, num_channels;
+		/*check if we use templates*/
 		stream = gf_list_get(pl->streams, i);
 		count_variants = gf_list_count(stream->variants);
 		for (j=0; j<count_variants; j++) {
@@ -1441,8 +1445,13 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 			}
 #endif
 
+			k = 0;
+try_next_segment:
+			k++;
+			elt = gf_list_get(pe->element.playlist.elements, k);
+			if (!elt)
+				break;
 			/*get rid of level 0 aac*/
-			elt = gf_list_get(pe->element.playlist.elements, 0);
 			if (elt && strstr(elt->url, ".aac"))
 				is_aac = GF_TRUE;
 
@@ -1457,7 +1466,6 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 				GF_Err e;
 				GF_MediaImporter import;
 				char *tmp_file = NULL;
-				elt = gf_list_get(pe->element.playlist.elements, 0);
 				memset(&import, 0, sizeof(GF_MediaImporter));
 				import.trackID = 0;
 				import.flags = GF_IMPORT_PROBE_ONLY;
@@ -1477,6 +1485,10 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 					import.in_name = elt->url;
 				}
 				e = gf_media_import(&import);
+				if (!e) {
+					GF_LOG(GF_LOG_WARNING, GF_LOG_DASH, ("[MPD] M3U8 missing Media Element %s (Playlist %s) %s \n", import.in_name, base_url));
+					goto try_next_segment;
+				}
 
 				if (import.in_name && !pe->bandwidth && pe->duration_info) {
 					u64 pos = 0;
@@ -1599,14 +1611,14 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 			if (is_aac)
 				fprintf(fmpd, " -->\n");
 		}
-	}
 
-	if (template_base) {
-		gf_free(template_base);
-		template_base = NULL;
-	}
+		if (template_base) {
+			gf_free(template_base);
+			template_base = NULL;
+		}
 
-	fprintf(fmpd, "  </AdaptationSet>\n");
+		fprintf(fmpd, "  </AdaptationSet>\n");
+	}
 	fprintf(fmpd, " </Period>\n");
 	fprintf(fmpd, "</MPD>");
 
